from gurobipy import *
class MDDF():
    def __init__(self, data: pd.DataFrame, input_cols: list, output_cols: list):
        self.data = data
        self.K = list(range(0,data.shape[0]))
        self.input = input_cols
        self.output = output_cols
        self.M = list(range(0,len(input_cols)))
        self.N = list(range(0,len(output_cols)))
        
    def res(self):
        TE = []
        for i in self.K:
            eff = self.__DDFmodel(i,self.data)
            TE.append(eff)
        self.data["DDF效率"] = TE
        return self.data
    
    def __DDFmodel(self, i,data):
        model = Model('DDF')
        model.Params.LogToConsole = 0
        lambdas = model.addVars(self.K, lb=0, vtype=GRB.CONTINUOUS, name='lambdas')
        beta = model.addVar(vtype = GRB.CONTINUOUS, name = 'beta')
        model.addConstrs(quicksum(lambdas[j] * data.loc[j,p] for j in self.K) 
                         <= (1-beta) * data.loc[i,p]  for p in self.input)
        model.addConstrs(quicksum(lambdas[j] * data.loc[j,q] for j in self.K) 
                         >= (1+beta) * data.loc[i,q]  for q in self.output)
        # model.addConstrs(quicksum(lambdas[j] * data.loc[j,u] for j in self.N) 
        #                  <= (1-beta) * data.loc[i,u]  for u in self.U)
        # model.addConstr(quicksum(lambdas[j] for j in self.N) == 1)
        model.setObjective(beta, GRB.MAXIMIZE)
        model.optimize()
        eff = model.getObjective().getValue() if model.status == gurobipy.GRB.Status.OPTIMAL else 'N/A'
        
        return eff
    
        
